﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace Test.Expressions
{
	/// <summary>
	/// An SQL OrderBy order type 
	/// </summary>
	public enum OrderType
	{
		Ascending,
		Descending
	}
	/// <summary>
	/// A pairing of an expression and an order type for use in a SQL Order By clause
	/// </summary>
	public class OrderExpression
	{
		OrderType orderType;
		Expression expression;
		public OrderExpression(OrderType orderType, Expression expression) {
			this.orderType = orderType;
			this.expression = expression;
		}
		public OrderType OrderType {
			get { return this.orderType; }
		}
		public Expression Expression {
			get { return this.expression; }
		}
	}
}
